function CPP.OnAddOnLoaded(event, addonName)
    if (addonName ~= CPP.name) then
        return;
    end

    EVENT_MANAGER:UnregisterForEvent(CPP.name, EVENT_ADD_ON_LOADED);

    CPP.vars = ZO_SavedVars:NewAccountWide("CPPSavedVariables", 1, nil, CPP.defaults, nil, "$InstallationWide");
    CPP.varsTemp = ZO_SavedVars:NewAccountWide("CPPTempProfilesSavedVariables", 1, nil, CPP.tempSaved, nil, "$InstallationWide");

    EVENT_MANAGER:RegisterForEvent(CPP.name, EVENT_PLAYER_ACTIVATED, CPP.OnPlayerActivated);
end

function CPP.OnPlayerActivated(eventCode, initial)
    EVENT_MANAGER:UnregisterForEvent(CPP.name, EVENT_PLAYER_ACTIVATED);

--    EVENT_MANAGER:RegisterForEvent(CPP.name, EVENT_CHAT_MESSAGE_CHANNEL, CPP.HandleChatMessage);

    CPP.Initialize();

    SLASH_COMMANDS["/cpp"] = CPP.OnCommand;

    SLASH_COMMANDS["/foo"] = function(extra)
        CPP.DeleteProfile("nopend");
    end
end

function CPP.HandleChatMessage(eventCode, channelType, fromName, text, isCustomerService, fromDisplayName)
    local splitted = split(text, ":");
    if (splitted[1] == "[CPP]") then
        local n = splitted[2];
        local h = splitted[3];

        if (CPP.IsHashValid(h)) then
            if table.getn(CPP.varsTemp.profiles) == 0 then
                table.insert(CPP.varsTemp.profiles, { name = n, hash = h });
            else
                for k, v in pairs(CPP.varsTemp.profiles) do
                    if (v.hash ~= h) then
                        table.insert(CPP.varsTemp.profiles, { name = n, hash = h });
                    end
                end
            end
        end
        CPP.ReloadDropdowns();
    end
end

function CPP.Initialize()
    CPP.RegisterMenu();
    CPP.InitializeDialogs();
end

function CPP.InitializeDialogs()
    local customControl = ZO_ChampionRespecConfirmationDialog;


    ZO_Dialogs_RegisterCustomDialog("CPP_CONFIRM_CP_WITH_GOLD", {
        gamepadInfo = {
            dialogType = GAMEPAD_DIALOGS.BASIC,
        },
        customControl = customControl,
        title = {
            text = SI_CHAMPION_DIALOG_CONFIRM_CHANGES_TITLE,
        },
        mainText = {
            text = zo_strformat(SI_CHAMPION_DIALOG_TEXT_FORMAT, GetString(SI_CHAMPION_DIALOG_CONFIRM_POINT_COST)),
        },
        setup = function()
            ZO_CurrencyControl_SetSimpleCurrency(customControl:GetNamedChild("BalanceAmount"), CURT_MONEY, GetCarriedCurrencyAmount(CURT_MONEY))
            ZO_CurrencyControl_SetSimpleCurrency(customControl:GetNamedChild("RespecCost"), CURT_MONEY, GetChampionRespecCost())
        end,
        buttons = {
            {
                control = customControl:GetNamedChild("Confirm"),
                text = SI_DIALOG_CONFIRM,
                callback = function()
                    CPP.RespecCPPoints(CPP.controls.selectedName);
                end,
            },
            {
                control = customControl:GetNamedChild("Cancel"),
                text = SI_DIALOG_CANCEL,
                callback = function()
                end,
            }
        }
    })

    ZO_Dialogs_RegisterCustomDialog("CPP_CONFIRM_CP_WITHOUT_GOLD", {
        gamepadInfo = {
            dialogType = GAMEPAD_DIALOGS.BASIC,
        },
        title = {
            text = SI_CHAMPION_DIALOG_CONFIRM_CHANGES_TITLE,
        },
        mainText = {
            text = CPP.Loc.GetString("CPP_CP_RESPEC_DIALOG_WITHOUT_GOLD"),
        },
        buttons = {
            {
                text = SI_DIALOG_CONFIRM,
                callback = function()
                    CPP.RespecCPPoints(CPP.controls.selectedName);
                end,
            },
            {
                text = SI_DIALOG_CANCEL,
                callback = function()
                end,
            }
        }
    })

    ZO_Dialogs_RegisterCustomDialog("CPP_RESPEC_IS_RUNNING", {
        gamepadInfo = {
            dialogType = GAMEPAD_DIALOGS.BASIC,
        },
        title = {
            text = SI_CHAMPION_DIALOG_CONFIRM_CHANGES_TITLE,
        },
        mainText = {
            text = "Warte bis der aktuelle Respec abgelaufen ist.",
        },
        buttons = {
            {
                text = SI_DIALOG_CONFIRM,
                callback = function()

                end,
            }
        }
    })
end

function CPP.OnCommand(extra)
    local options = {}
    local searchResult = { string.match(extra, "^(%S*)%s*(.-)$") }
    for i, v in pairs(searchResult) do
        if (v ~= nil and v ~= "") then
            options[i] = string.lower(v)
        end
    end

    if (string.lower(options[1]) == "remove") then
        if (options[2] ~= nil) then
            CPP.DeleteProfile(options[2], true);
        else
            CPP.Notify(CPP.Loc.GetString("CPP_ERR_NO_NAME"));
        end
    end

    if (string.lower(options[1]) == "remove-all") then
        CPP.DeleteAllProfiles();
    end

    if (string.lower(options[1]) == "remove-temp") then
        CPP.DeleteAllTempProfiles();
    end
end

EVENT_MANAGER:RegisterForEvent(CPP.name, EVENT_ADD_ON_LOADED, CPP.OnAddOnLoaded);
