function CPP.RespecCPPoints(name)
    if CPP.respecRunning then
        return;
    end

    CPP.respecRunning = true;

    local profile = "";

    for k, v in pairs(CPP.vars.profiles) do
        if (string.lower(v.name) == string.lower(name)) then
            profile = CPP.vars.profiles[k];
        end
    end

    if (profile == "") then
        CPP.Notify(CPP.Loc.GetString("CPP_PROFILE_UNVALID"));
        return;
    end


    local skills = split(profile.hash, "$");

    for k, v in pairs(skills) do
        skills[k] = split(v, "&");
    end

    SetChampionIsInRespecMode(true);

    CPP.ClearCPPoints();

    zo_callLater(function()
        CPP.Notify(CPP.Loc.GetString("CPP_NOTIFY_LOAD_START"));
        CPP.StartRespec(skills);
    end, 1000);
end

function CPP.ClearCPPoints()
    CPP.Notify(CPP.Loc.GetString("CPP_NOTIFY_RESET_POINTS"));
    ClearPendingChampionPoints();
    SpendPendingChampionPoints(true);
end

function CPP.StartRespec(skills)
    zo_callLater(function()
        CPP.SpendCPSkill(3, 3, skills[3][3]);
        SpendPendingChampionPoints(true);

        zo_callLater(function()
            CPP.SpendCPSkill(3, 4, skills[3][4]);
            SpendPendingChampionPoints(true);

            zo_callLater(function()
                CPP.SpecSkills(1, 1, skills);
            end)
        end, CPP.respecCooldown);
    end, CPP.respecCooldown);
end

function CPP.SpecSkills(discipline, skill, arr)
    if (discipline > 9) then
        CPP.Notify(CPP.Loc.GetString("CPP_NOTIFY_LOAD_FINISH"));
        SpendPendingChampionPoints(true);
        SetChampionIsInRespecMode(false);
        CPP.respecRunning = false;
        return;
    end

    zo_callLater(function()
        if (discipline ~= 3) then
            CPP.SpendCPSkill(discipline, skill, arr[discipline][skill]);
        else
            if (skill == 1 or skill == 2) then
                CPP.SpendCPSkill(discipline, skill, arr[discipline][skill]);
                CPP.SpendCPSkill(discipline, skill, arr[discipline][skill]);
            end
        end

        local nDisc = discipline;
        local nSkill = skill + 1;

        if (nSkill > 4) then
            nSkill = 1;
            nDisc = nDisc + 1;
        end

        CPP.SpecSkills(nDisc, nSkill, arr);
    end, CPP.respecCooldown);
end

function CPP.SpendCPSkill(i, j, value)
    if tonumber(value) > 0 then
        SetNumPendingChampionPoints(i, j, tonumber(value));
    end
end
